package com.diagbot.facade;

import com.diagbot.util.DateUtil;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/5/7 13:53
 */
@Component
public class FilterFacade {
    /**
     * 筛选起始时间
     *
     * @param type
     * @return
     */
    public String getStartDateStr(Integer type, Integer optYear) {
        Date date = new Date();
        String startDate = "";
        String year = optYear == null ? DateUtil.getYear(date) : optYear.toString();
        int month = DateUtil.getMonth(date);
        if (type.equals(1)) {
            //本月统计
            startDate = year + "-" + month + "-1";
        } else if (type.equals(2)) {
            //本年统计
            startDate = year + "-1-1";
        }
        return startDate;
    }

    /**
     * 筛选截止时间
     *
     * @param type
     * @return
     */
    public String getEndDateStr(Integer type, Integer optYear) {
        Date date = new Date();
        String endDate = "";
        String year = optYear == null ? DateUtil.getYear(date) : optYear.toString();
        int month = DateUtil.getMonth(date);
        if (type.equals(1)) {
            //本月统计
            if (month == 12) {
                endDate = (Integer.valueOf(year) + 1) + "-1-1";
            } else {
                endDate = year + "-" + (month + 1) + "-1";
            }
        } else if (type.equals(2)) {
            //本年统计
            endDate = (Integer.valueOf(year) + 1) + "-1-1";
        }
        return endDate;
    }

    /**
     * 上一统计周期（上月/去年）的起始时间
     *
     * @param type
     * @return
     */
    public String getLastStartDateStr(Integer type) {
        Date date = new Date();
        String dateStr = "";
        String year = DateUtil.getYear(date);
        int month = DateUtil.getMonth(date);
        if (type.equals(1)) {
            if (month == 1) {
                dateStr = (Integer.valueOf(year) - 1) + "-12-1";
            } else {
                dateStr = year + "-" + (month - 1) + "-1";
            }
        } else if (type.equals(2)) {
            dateStr = (Integer.valueOf(year) - 1) + "-1-1";
        }
        return dateStr;
    }

    /**
     * 获取上一统计周期（上月/去年）的起始时间
     *
     * @param type
     * @return
     */
    public String getLastEndDateStr(Integer type) {
        //上一统计周期的截止时间等于本周期的起始时间
        return getStartDateStr(type, null);
    }
}
